DEFINT A-Z
'$INCLUDE: '..\include\Declare.bi'
'$INCLUDE: '..\include\future.bi'
'$INCLUDE: '..\include\Const.bi'
'$INCLUDE: '..\include\share.bi'
TYPE RegType
     ax    AS INTEGER
     bx    AS INTEGER
     CX    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
END TYPE
TYPE RegTypeX
     ax    AS INTEGER
     bx    AS INTEGER
     CX    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
     ds    AS INTEGER
     es    AS INTEGER
END TYPE
DECLARE SUB INTERRUPT (intnum AS INTEGER, inreg AS RegType, OutReg AS RegType)
DECLARE SUB INTERRUPTX (intnum AS INTEGER, inreg AS RegTypeX, OutReg AS RegTypeX)
DECLARE SUB ABSOLUTE (address AS INTEGER)

DIM SHARED inreg AS RegTypeX, OutReg AS RegTypeX

SUB ClearArray (Array)
DIM nul AS INTEGER
nul = 0
Rows = GetArrRows(Array)
FOR I = 1 TO Rows
CALL putarrs(Array, I, "")
NEXT
CALL MoveToXMS(Array, VARSEG(nul), VARPTR(nul), 2, 8)

END SUB

SUB drawborder (X, Y, X1, Y1, cu AS LONG, cf AS LONG, cd AS LONG)
CALL Future.FILLBOX(X + 1, Y + 1, X1 - 1, Y1 - 1, cf)

CALL Future.LINE(X, Y, X1, Y, cu, -1)
CALL Future.LINE(X, Y, X, Y1, cu, -1)

CALL Future.LINE(X, Y1, X1, Y1, cd, -1)
CALL Future.LINE(X1, Y, X1, Y1, cd, -1)

END SUB

SUB drawFrame (X, Y, X1, Y1, cu AS LONG, cd AS LONG)
CALL Future.LINE(X, Y, X1, Y, cu, -1)
CALL Future.LINE(X, Y, X, Y1, cu, -1)
CALL Future.LINE(X, Y1, X1, Y1, cd, -1)
CALL Future.LINE(X1, Y, X1, Y1, cd, -1)
END SUB

SUB drawpicto (X, Y, XL, n, UC AS LONG, BC AS LONG, Tc AS LONG, DC AS LONG)

CALL Future.FILLBOX(X + 1, Y + 1, X + XL - 1, Y + XL - 1, BC)
CALL Future.LINE(X, Y, X + XL, Y, UC, -1)
CALL Future.LINE(X, Y, X, Y + XL, UC, -1)

CALL Future.LINE(X, Y + XL, X + XL, Y + XL, DC, -1)
CALL Future.LINE(X + XL, Y, X + XL, Y + XL, DC, -1)




SELECT CASE n
CASE 0
CASE 1  'close
CALL Future.LINE(X + 2, Y + 2, X + XL - 2, Y + XL - 2, Tc, -1)
CALL Future.LINE(X + 2, Y + XL - 2, X + XL - 2, Y + 2, Tc, -1)


IF XL > 10 THEN
CALL Future.LINE(X + 3, Y + 2, X + XL - 2, Y + XL - 3, Tc, -1)
CALL Future.LINE(X + 2, Y + XL - 3, X + XL - 3, Y + 2, Tc, -1)
CALL Future.LINE(X + 2, Y + 3, X + XL - 3, Y + XL - 2, Tc, -1)
CALL Future.LINE(X + 3, Y + XL - 2, X + XL - 2, Y + 3, Tc, -1)
END IF
CASE 2  'max

CALL Future.BOX(X + 2, Y + 2, X + XL - 2, Y + XL - 2, Tc)

IF XL > 10 THEN
CALL Future.BOX(X + 2, Y + 3, X + XL - 2, Y + XL - 2, Tc)
'CALL Future.FillBox(X + 2, Y + 4, X + XL - 2, Y + XL - 2, TC)
END IF
CASE 3  'Default
IF XL >= 10 THEN
CALL Future.BOX(X + 1, Y + XL - 2, X + XL / 2 + 1, Y + XL / 2 - 2, Tc)
CALL Future.BOX(X + XL / 2 - 2, Y + XL / 2 + 2, X + XL - 2, Y + 2, Tc)
END IF

IF XL < 10 THEN
CALL Future.BOX(X + 1, Y + XL - 1, X + XL / 2, Y + XL / 2 - 1, Tc)
CALL Future.BOX(X + XL / 2, Y + XL / 2, X + XL - 2, Y + 1, Tc)

END IF
CASE 4  'Min
IF XL >= 10 THEN
CALL Future.FILLBOX(X + 2, Y + XL - 2, X + XL - 3, Y + XL - 3, Tc)
END IF
IF XL < 10 THEN
CALL Future.LINE(X + 1, Y + XL - 1, X + XL - 2, Y + XL - 1, Tc, -1)
END IF
CASE 5  'Galka
CALL Future.LINE(X + 1, Y + 3, X + XL / 2 - 1, Y + XL / 2 + 1, Tc, -1)
CALL Future.LINE(X + 1, Y + 4, X + XL / 2 - 1, Y + XL / 2 + 2, Tc, -1)
CALL Future.LINE(X + XL / 2 - 1, Y + XL / 2 + 1, X + XL - 2, Y + 2, Tc, -1)
CALL Future.LINE(X + XL / 2 - 1, Y + XL / 2 + 2, X + XL - 2, Y + 3, Tc, -1)

CASE 6  ' circle
CALL Future.FILLCIRCLE(X + XL / 2, Y + XL / 2, XL / 2 - 2, Tc)

CASE 7  'Up
YY = XL / 3
FOR l = 0 TO FIX(XL / 2) - 2
YY = YY + 1
CALL Future.LINE(X - l + XL / 2, Y + YY, X + l + XL / 2, Y + YY, Tc, -1)
NEXT

'CALL FILLAREA(X + XL / 2, Y + XL / 2, TC, TC)
CASE 8  'Down
YY = 2 * XL / 3
FOR l = 0 TO FIX(XL / 2) - 2
YY = YY - 1
CALL Future.LINE(X - l + XL / 2, Y + YY, X + l + XL / 2, Y + YY, Tc, -1)
NEXT

CASE 9  'Left
XX = XL / 3
FOR l = 0 TO FIX(XL / 2) - 2
XX = XX + 1
CALL Future.LINE(X + XX, Y - l + XL / 2, X + XX, Y + l + XL / 2, Tc, -1)
NEXT

CASE 10  'Right
XX = 2 * XL / 3
FOR l = 0 TO FIX(XL / 2) - 2
XX = XX - 1
CALL Future.LINE(X + XX, Y - l + XL / 2, X + XX, Y + l + XL / 2, Tc, -1)
NEXT

CASE 11  'Left\UP
CALL Future.LINE(X + 2, Y + 2, X + 2, Y + XL - 2, Tc, -1)
CALL Future.LINE(X + 2, Y + 2, X + XL - 2, Y + 2, Tc, -1)
CALL Future.LINE(X + XL - 2, Y + 2, X + 2, Y + XL - 2, Tc, -1)
'CALL FILLAREA(X + 3, Y + 3, TC, TC)

END SELECT

END SUB

FUNCTION FRMTSTR$ (TextS$)
n = INSTR(TextS$, CHR$(0))
IF n > 1 THEN
FRMTSTR$ = MID$(TextS$, 1, n - 1)
END IF
IF n <= 1 THEN
FRMTSTR$ = ""
END IF
END FUNCTION

FUNCTION GetArrCols (Array)
DIM siz AS INTEGER

CALL MoveFromXMS(Array, VARSEG(siz), VARPTR(siz), 2, 3)

GetArrCols = siz

END FUNCTION

FUNCTION GetArrRows (Array)
DIM siz AS INTEGER

CALL MoveFromXMS(Array, VARSEG(siz), VARPTR(siz), 2, 6)

GetArrRows = siz


END FUNCTION

FUNCTION getarrs$ (Array, n)
DIM siz AS INTEGER
CALL MoveFromXMS(Array, VARSEG(siz), VARPTR(siz), 2, 3)
sl& = siz

values$ = STRING$(sl&, CHR$(0))

of& = n
of& = of& * sl& + 10

CALL MoveFromXMS(Array, SSEG(values$), SADD(values$), sl&, of&)

getarrs$ = FRMTSTR(values$)

END FUNCTION

FUNCTION GetCurDir$
'-----------Remember current drive--------
   inreg.ax = &H1900
   CALL INTERRUPTX(&H21, inreg, OutReg)
   cd = (OutReg.ax AND 255) + 1
'-----------Get drives--------

'cd = 4
DIM Buffer(128)

aseg = VARSEG(Buffer(0))
aptr = VARPTR(Buffer(0))

inreg.ax = &H4700
inreg.dx = cd
inreg.ds = aseg
inreg.si = aptr
CALL INTERRUPTX(&H21, inreg, OutReg)
IF OutReg.ax = 15 THEN
ERROR 68       'no such drive
ELSE
DEF SEG = aseg
FOR a = 0 TO 128
f$ = f$ + CHR$(PEEK(aptr + a))
NEXT
DEF SEG
s$ = CHR$(cd + 64) + ":\" + LEFT$(f$, INSTR(f$, CHR$(0)) - 1)
IF LEFT$(s$, 1) <> "\" THEN s$ = s$ + "\"
GetCurDir$ = s$
END IF

END FUNCTION

SUB GetDirs (Directory$, Array)
ClearArray Array
inreg.CX = 16 + 1 + 2 + 4 + 128 + 64'(215)
inreg.ax = &H4E00
FMask$ = Directory$ + "*.*" + CHR$(0)
inreg.ds = SSEG(FMask$)
inreg.dx = SADD(FMask$)
CALL INTERRUPTX(&H21, inreg, OutReg)
'IF OutReg.flags AND (OutReg.ax = 2 OR OutReg.ax = &H12) THEN EXIT SUB '᫨ a  -  室.
con = 1
DO
inreg.ax = &H2F00
CALL INTERRUPTX(&H21, inreg, OutReg)
DEF SEG = OutReg.es
FileName$ = ""
FOR I = &H1E TO &H2A
symbol$ = CHR$(PEEK(OutReg.bx + I))
IF symbol$ = CHR$(0) THEN EXIT FOR
FileName$ = FileName$ + symbol$
NEXT
IF FileName$ <> "." THEN

dirs$ = UCASE$(FileName$)
CALL putarrs(Array, con, dirs$)
con = con + 1
END IF
inreg.ax = &H4F00
inreg.CX = 215
CALL INTERRUPTX(&H21, inreg, OutReg)
LOOP UNTIL (OutReg.flags AND (OutReg.ax = 2 OR OutReg.ax = &H12))


END SUB

SUB GetDrives (Array)
ClearArray Array

'-----------Remember current drive--------
     inreg.ax = &H1900
          CALL INTERRUPTX(&H21, inreg, OutReg)
          cd = (OutReg.ax AND 255)
          '-----------Get drives--------
k = 1
FOR I = 1 TO 25
        DrNumber = I
    IF DrNumber >= 0 AND DrNumber <= 25 THEN
      inreg.ax = &HE00
      inreg.dx = DrNumber
   
      CALL INTERRUPTX(&H21, inreg, OutReg)
      inreg.ax = &H1900
     CALL INTERRUPTX(&H21, inreg, OutReg)
      IF DrNumber <> (OutReg.ax AND 255) THEN
        'PRINT
      ELSE
      'PRINT "Drive "; DrNumber; " Exists"
      C$ = CHR$(I + 64) + ":\"
      IF C$ <> "B:\" THEN
      'Drives(k) = c$
      putarrs Array, k, C$
      k = k + 1
      END IF
      END IF
 
    END IF
NEXT
'-----------Return current drive--------
      inreg.ax = &HE00
            inreg.dx = cd
                  CALL INTERRUPTX(&H21, inreg, OutReg)


END SUB

FUNCTION GetFArrRows (Array)
DIM siz AS INTEGER
CALL MoveFromXMS(Array, VARSEG(siz), VARPTR(siz), 2, 8)
GetFArrRows = siz
END FUNCTION

SUB GetFiles (Directory$, Array, Mask$)
ClearArray Array
s$ = DIR$(Directory$ + Mask$)
CALL putarrs(Array, 1, s$)
I = 1
DO UNTIL s$ = ""
I = I + 1
s$ = DIR$
CALL putarrs(Array, I, s$)
LOOP

END SUB

FUNCTION GetMyName$

  inreg.ax = &H6200
  INTERRUPTX &H21, inreg, OutReg
  PSPStart% = OutReg.bx

  DEF SEG = PSPStart%
  EnvironStart% = PEEK(&H2D) * 256 + PEEK(&H2C)
  DEF SEG

  DEF SEG = EnvironStart%
  DO
    Char = PEEK(a)
    IF Char = 0 THEN
      a = a + 1
      Char = PEEK(a)
      IF Char = 0 THEN
        Found = 1
      END IF
    END IF
    a = a + 1
  LOOP UNTIL Found = 1
  a = a + 2
  Found = False
  DO
    Char = PEEK(a)
    IF Char = 0 THEN
      Found = 1
    ELSE
      Path$ = Path$ + CHR$(Char)
    END IF
    a = a + 1
  LOOP UNTIL Found = 1
  DEF SEG
  GetMyName$ = Path$


END FUNCTION

SUB GetRowCol (Index, Cols, Row, Col)
Row = FIX((Index - 1) / Cols) + 1
Col = Index - (Row - 1) * Cols
END SUB

SUB insertLines (Array, StartRow, NRows)
AC& = GetArrCols(Array)

ar& = GetArrRows(Array)
Nr& = NRows

frows = GetFArrRows(Array)

frows = frows + NRows

IF frows > ar& THEN frows = ar&

sr& = StartRow

nxs& = (AC& * ar&)
ar2 = AllocateXMS(nxs&)
st& = sr& * AC& + 10
ln& = AC& * ar& - st&
CALL MoveXMS(Array, 0, ar2, 0, ar& * AC&)
CALL MoveXMS(ar2, st&, Array, st& + Nr& * AC&, ln&)

FOR I = sr& TO sr& + Nr& - 1
CALL putarrs(Array, I, STRING$(AC&, CHR$(0)))
NEXT
CALL MoveToXMS(Array, VARSEG(frows), VARPTR(frows), 2, 8)

DeallocateXMS (ar2)
END SUB

FUNCTION isdiskready (Drive$)
IF LEN(Drive$) = 0 THEN EXIT FUNCTION
Dr = ASC(UCASE$(MID$(Drive$, 1, 1))) - 64
inreg.ax = &H1C00
 inreg.dx = Dr
 INTERRUPTX &H21, inreg, OutReg
 IF OutReg.bx = 0 THEN
 isdiskready = 0
 ELSE
    isdiskready = NOT (0)     'Ready
 END IF





END FUNCTION

SUB LoadPicture (FileName$, Array, ImgIndex)
IF CurPage = 1 THEN CP = 0 ELSE CP = 1
SetPage CP

tit$ = FileName$
IF LEN(tit$) > 4 THEN
IF UCASE$(RIGHT$(tit$, 4)) = ".BMP" THEN CALL Future.LoadBMP(tit$, 0, 0)
IF UCASE$(RIGHT$(tit$, 4)) = ".PCX" THEN CALL Future.LoadPCX(tit$, 0, 0)
IF UCASE$(RIGHT$(tit$, 4)) = ".GIF" THEN CALL Future.LoadGIF(tit$, 0, 0)
END IF
Future.XMSArrayGet 0, 0, Array, ImgIndex

IF CP = 1 THEN CP = 0 ELSE CP = 1
SetPage CP



END SUB

SUB LoadSystem (XRes, YRes, Bits)
Sys.HeadSize = 20
Sys.MaxX = XRes
Sys.MaxY = YRes
Sys.Font = 1

IF Bits = 8 THEN
Sys.HeadColor = 9
Sys.BColor = 7
Sys.UpColor = 15
Sys.DownColor = 8
Sys.TextBColor = 7
Sys.Bits = Bits
k = 1
END IF
IF Bits = 16 OR Bits = 15 THEN
Sys.HeadColor = RGB2Color(0, 0, 63)'CBrBlue
Sys.BColor = RGB2Color(50, 50, 50)
Sys.UpColor = RGB2Color(63, 63, 63)
Sys.DownColor = RGB2Color(10, 10, 10)
Sys.TextBColor = RGB2Color(55, 55, 55)
Sys.Bits = Bits
k = 1
END IF

IF Bits = 32 THEN
Sys.HeadColor = RGB2Color(0, 0, 220)'CBrBlue
Sys.BColor = RGB2Color(150, 150, 150)
Sys.UpColor = RGB2Color(255, 255, 255)
Sys.DownColor = RGB2Color(100, 100, 100)
Sys.TextBColor = RGB2Color(220, 220, 220)
Sys.Bits = Bits
k = 1
END IF
IF k = 0 THEN
PRINT "Bits parameter must be 8, 15, 16 or 32"
END
END IF
IF k = 1 THEN

IF NOT (IsVESA) THEN
PRINT "Your Video card doesn`t support VESA mode"
END
END IF
IF NOT (IsXMSInstalled) THEN
PRINT "Programm can`t found XMS memory"
END
END IF

CALL SetScreenMode(XRes, YRes, Bits)

END IF
Refreshed = 1
END SUB

SUB MoveControl (ID, dx, DY)
DIM cc AS LONG

OBJ = GetProp(ID, PObject)
IF OBJ = OForm THEN
XP = GetProp(ID, PXPos)
YP = GetProp(ID, PYPos)
ELSE
XP = GetProp(ID, PRXPos)
YP = GetProp(ID, PRYPos)
END IF

XL = GetProp(ID, PXLen)
YL = GetProp(ID, PYLen)
X = Future.MouseX
Y = Future.MouseY

XM = X
YM = Y

LLX& = SizeOf(XL, 1)
LLY& = SizeOf(1, YL)


H1 = AllocateXMS(LLY&)
H2 = AllocateXMS(LLX&)
H11 = AllocateXMS(LLX&)
H22 = AllocateXMS(LLY&)

CALL Future.XMSget(XP, YP, XP, YP + YL, H1)
CALL Future.XMSget(XP, YP, XP + XL, YP, H2)

CALL Future.XMSget(XP, YP + YL, XP + XL, YP + YL, H11)
CALL Future.XMSget(XP + XL, YP, XP + XL, YP + YL, H22)

Future.MouseOff
MoBu1 = Future.MouseB
cc = Sys.UpColor
DO

CALL Future.LINE(XP - dx, YP - DY, XP - dx, YP + YL - DY, cc, -1)
CALL Future.LINE(XP - dx, YP - DY, XP + XL - dx, YP - DY, cc, -1)

CALL Future.LINE(XP - dx, YP + YL - DY, XP + XL - dx, YP + YL - DY, cc, -1)
CALL Future.LINE(XP + XL - dx, YP - DY, XP + XL - dx, YP + YL - DY, cc, -1)
DX2 = dx
DY2 = DY

DO
Future.UpdateMouse
xm1 = XM
YM1 = YM

XM = Future.MouseX
YM = Future.MouseY
MoBu = Future.MouseB
LOOP UNTIL xm1 <> XM OR YM1 <> YM OR MoBu <> MoBu1
dx = X - XM
DY = Y - YM
CALL Future.XMSput(XP - DX2, YP - DY2, H1)
CALL Future.XMSput(XP - DX2, YP - DY2, H2)

CALL Future.XMSput(XP - DX2, YP + YL - DY2, H11)
CALL Future.XMSput(XP + XL - DX2, YP - DY2, H22)

'CALL future.Line(XP - DX2, YP - DY2, XP - DX2, YP + YL - DY2, CBrWhite, -1)

CALL Future.XMSget(XP - dx, YP - DY, XP - dx, YP + YL - DY, H1)
CALL Future.XMSget(XP - dx, YP - DY, XP + XL - dx, YP - DY, H2)

CALL Future.XMSget(XP - dx, YP + YL - DY, XP + XL - dx, YP + YL - DY, H11)
CALL Future.XMSget(XP + XL - dx, YP - DY, XP + XL - dx, YP + YL - DY, H22)

'   CALL future.Line(XP - DX, YP - DY, XP - DX, YP + YL - DY, CBrWhite, -1)





LOOP UNTIL MoBu <> MoBu1
DeallocateXMS (H1)
DeallocateXMS (H2)
DeallocateXMS (H11)
DeallocateXMS (H22)
Future.MouseOn



END SUB

FUNCTION newArray (NRows, nColls)
DO
dll& = nColls
dll& = dll& * NRows

H = AllocateXMS(dll&)

CALL MoveToXMS(H, VARSEG(nColls), VARPTR(nColls), 2, 3)
CALL MoveToXMS(H, VARSEG(NRows), VARPTR(NRows), 2, 6)

FOR I = 1 TO NRows
CALL putarrs(H, I, STRING$(nColls, CHR$(0)))
NEXT

CALL MoveToXMS(H, VARSEG(nul), VARPTR(nul), 2, 8)

IF H <> 0 THEN
EXIT DO
ELSE
DeallocateXMS (H)
R = AllocateXMS(20)
END IF
LOOP
newArray = H

END FUNCTION

FUNCTION NewImgArray (XLen, YLen, NumOfImages)
IF NumOfImages = 0 THEN NumOfImages = 1
IF XLen = 0 OR YLen = 0 THEN EXIT FUNCTION
l& = SizeOf(XLen, YLen) * NumOfImages
a = AllocateXMS(l&)
Future.DefineXMSArray XLen, YLen, a
NewImgArray = a
END FUNCTION

SUB PrintGfx (X, Y, t$, Tc&, BC&)
CALL Future.PRINT(X, Y, t$, Tc&, BC&)
END SUB

SUB PrintInBox (X, Y, X1, Y1, Text$, Style, Tc AS LONG, BC AS LONG)
TLE = LEN(Text$) * 8
IF CurFontSize > 0 THEN fts = CurFontSize ELSE CurFontSize = 16
IF TLE < X1 - X AND INSTR(1, Text$, CHR$(13)) = 0 THEN
IF Style = 0 THEN
XP = X
YP = Y + ((Y1 - Y) / 2 - fts / 2)
END IF
IF Style = 1 THEN
XP = X + ((X1 - X) / 2 - TLE / 2)
YP = Y + ((Y1 - Y) / 2 - fts / 2)
END IF

CALL PrintGfx(XP, YP, Text$, Tc, BC)
ELSE
YY = Y
I = 1
DO

il = INSTR(I, Text$, CHR$(13)) - I

IF il <= 0 THEN l = (X1 - X) \ 8: Pi = 0
IF il > 0 THEN l = il: Pi = 1

s$ = MID$(Text$, I, l)

IF Style = 0 THEN
XP = X
END IF
IF Style = 1 THEN
XP = X + ((X1 - X) / 2 - l * 8 / 2)
END IF
CALL PrintGfx(XP, YY, s$, Tc, BC)
I = I + l + Pi
YY = YY + fts
LOOP UNTIL I >= TLE
END IF

END SUB

SUB putarrs (Array, n, values$)
IF Array = 0 THEN EXIT SUB

'CALL MoveFromXMS(Array, VARSEG(siz), VARPTR(siz), 2, 3)
CALL MoveFromXMS(Array, VARSEG(FSiz), VARPTR(FSiz), 2, 8)


sl& = GetArrCols(Array)

s$ = STRING$(sl&, CHR$(0))

'-------
IF LEN(values$) > sl& THEN
values$ = MID$(values$, 1, sl&)
END IF

MID$(s$, 1, LEN(values$)) = values$


of& = n
of& = of& * sl& + 10

CALL MoveToXMS(Array, SSEG(s$), SADD(s$), sl&, of&)
IF n > FSiz AND values$ <> "" THEN CALL MoveToXMS(Array, VARSEG(n), VARPTR(n), 2, 8)

END SUB

SUB Removelines (Array, StartRow, NRows)
AC = GetArrCols(Array)
ar = GetArrRows(Array)
nFRows = GetFArrRows(Array) - NRows
IF nFRows < 0 THEN nFRows = 0
FOR I = 0 TO ar
s$ = getarrs(Array, I)
IF I < StartRow OR I >= StartRow + NRows THEN
CALL putarrs(Array, k, s$)
k = k + 1

END IF
NEXT
CALL putarrs(Array, ar, "")

CALL MoveToXMS(Array, VARSEG(nFRows), VARPTR(nFRows), 2, 8)


END SUB

SUB ResizeControl (ID, dx, DY)
DIM cc AS LONG

OBJ = GetProp(ID, PObject)
IF OBJ = OForm THEN
XP = GetProp(ID, PXPos)
YP = GetProp(ID, PYPos)
ELSE
XP = GetProp(ID, PRXPos)
YP = GetProp(ID, PRYPos)
END IF

XL = GetProp(ID, PXLen)
YL = GetProp(ID, PYLen)
X = Future.MouseX
Y = Future.MouseY

XM = X
YM = Y

LLX& = SizeOf(XL, 1)
LLY& = SizeOf(1, YL)


H1 = AllocateXMS(LLY&)
H2 = AllocateXMS(LLX&)
H11 = AllocateXMS(LLX&)
H22 = AllocateXMS(LLY&)

CALL Future.XMSget(XP, YP, XP, YP + YL, H1)
CALL Future.XMSget(XP, YP, XP + XL, YP, H2)

CALL Future.XMSget(XP, YP + YL, XP + XL, YP + YL, H11)
CALL Future.XMSget(XP + XL, YP, XP + XL, YP + YL, H22)

Future.MouseOff
MoBu1 = Future.MouseB
cc = Sys.UpColor
DO

CALL Future.LINE(XP, YP, XP, YP + YL - DY, cc, -1)
CALL Future.LINE(XP, YP, XP + XL - dx, YP, cc, -1)

CALL Future.LINE(XP, YP + YL - DY, XP + XL - dx, YP + YL - DY, cc, -1)
CALL Future.LINE(XP + XL - dx, YP, XP + XL - dx, YP + YL - DY, cc, -1)
DX2 = dx
DY2 = DY

DO
Future.UpdateMouse
xm1 = XM
YM1 = YM

XM = Future.MouseX
YM = Future.MouseY
MoBu = Future.MouseB
LOOP UNTIL xm1 <> XM OR YM1 <> YM OR MoBu <> MoBu1
dx = X - XM
DY = Y - YM
IF XP + XL - dx < XP THEN dx = XL
IF YP + YL - DY < YP THEN DY = YL



CALL Future.XMSput(XP, YP, H1)
CALL Future.XMSput(XP, YP, H2)

CALL Future.XMSput(XP, YP + YL - DY2, H11)
CALL Future.XMSput(XP + XL - DX2, YP, H22)


CALL Future.XMSget(XP, YP, XP, YP + YL - DY, H1)
CALL Future.XMSget(XP, YP, XP + XL - dx, YP, H2)

CALL Future.XMSget(XP, YP + YL - DY, XP + XL - dx, YP + YL - DY, H11)
CALL Future.XMSget(XP + XL - dx, YP, XP + XL - dx, YP + YL - DY, H22)

LOOP UNTIL MoBu <> MoBu1
DeallocateXMS (H1)
DeallocateXMS (H2)
DeallocateXMS (H11)
DeallocateXMS (H22)
Future.MouseOn



END SUB

SUB ShowControl (ID)
DIM Tc AS LONG, BC AS LONG, UC AS LONG, DC AS LONG, HC AS LONG


IF GetProp(ID, PNoRefresh) <> 0 OR ID = 0 THEN EXIT SUB

OBJ = GetProp(ID, PObject)
RVis = GetProp(ID, PRVisible)
Vis = GetProp(ID, PVisible)

XP = GetProp(ID, PXPos)
YP = GetProp(ID, PYPos)

XPR = GetProp(ID, PRXPos)
Ypr = GetProp(ID, PRYPos)

XL = GetProp(ID, PXLen)
YL = GetProp(ID, PYLen)

st = GetProp(ID, PStyle)
X = XPR
Y = Ypr
X1 = XPR + XL
Y1 = Ypr + YL
Tc = GetLProp(ID, PTColor)
BC = GetLProp(ID, PBColor)
UC = GetLProp(ID, PUpColor)
DC = GetLProp(ID, PDownColor)
ft = GetLProp(ID, PFont)
SetFont ft
IF ft = 0 THEN fts = 8
IF ft = 1 THEN fts = 16
IF ft = 2 THEN fts = 14
CurFontSize = fts
HC = Sys.HeadColor

tit$ = title(ID)

TLE = LEN(tit$) * 8

'-------------------------------------------Form------------------------------'-------------------------------------------Form--------------------------------
IF OBJ = OForm AND Vis <> 0 THEN
X1 = XP + XL
Y1 = YP + YL
STa = GetProp(ID, PState)
IF ID = 1 THEN
Future.CLS BC
CALL drawFrame(XP, YP, X1, Y1, UC, DC)
ELSE
CALL drawborder(XP, YP, X1, Y1, UC, BC, DC)
END IF

IF ID = ActiveForm(focus.ID) THEN
CALL drawborder(XP, YP, X1, YP + Sys.HeadSize, Sys.UpColor, Sys.HeadColor, Sys.DownColor)
CALL PrintGfx(XP + 3, YP + 3, tit$, Tc, -1)
ELSE
CALL drawborder(XP, YP, X1, YP + Sys.HeadSize, Sys.UpColor, Sys.DownColor, Sys.DownColor)
CALL PrintGfx(XP + 3, YP + 3, tit$, Tc, -1)

END IF
IF (CNoClose AND st) = 0 THEN
CALL drawpicto(X1 - Sys.HeadSize + 2, YP + 2, Sys.HeadSize - 4, 1, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF
IF (CNoMax AND st) = 0 AND STa = CDefault THEN
CALL drawpicto(X1 - Sys.HeadSize * 2 + 2, YP + 2, Sys.HeadSize - 4, 2, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF
IF (CNoMax AND st) = 0 AND STa = CMax THEN
CALL drawpicto(X1 - Sys.HeadSize * 2 + 2, YP + 2, Sys.HeadSize - 4, 3, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF
IF STa = CMin THEN
CALL drawpicto(X1 - Sys.HeadSize * 2 + 2, YP + 2, Sys.HeadSize - 4, 3, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF
IF (CNoMin AND st) = 0 AND STa <> CMin THEN
CALL drawpicto(X1 - Sys.HeadSize * 3 + 4, YP + 2, Sys.HeadSize - 4, 4, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF
IF (CNoResize AND st) = 0 AND STa = CDefault THEN
CALL drawpicto(X1 - 8, Y1 - 8, 8, 11, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF

END IF
'-------------------------------------------Button----------------------------'-------------------------------------------Button----------------------------
IF OBJ = OButton AND RVis <> 0 THEN
IF st AND CCenter THEN s = 1 ELSE s = 0
X = 0
Y = 0
IF GetProp(ID, PLMDown) THEN
IF st AND CNoBorder THEN  ELSE CALL drawborder(XPR, Ypr, X1, Y1, DC, BC, UC)
IF st AND CPicture THEN  ELSE CALL PrintInBox(XPR + 4, Ypr + 4, X1 - 2, Y1 - 2, tit$, s, Tc, -1)
X = 1
Y = 1
ELSE
IF st AND CNoBorder THEN  ELSE CALL drawborder(XPR, Ypr, X1, Y1, UC, BC, DC)
IF st AND CPicture THEN  ELSE CALL PrintInBox(XPR + 2, Ypr + 2, X1 - 2, Y1 - 2, tit$, s, Tc, -1)
IF ID = focus.ID AND (st AND CNoBorder) = 0 THEN
CALL drawFrame(XPR + 1, Ypr + 1, X1 - 1, Y1 - 1, UC, DC)
END IF

END IF

IF st AND CPicture THEN
SetViewPort XPR + 1, Ypr + 1, X1, Y1
X = XPR + 1 + X
Y = Ypr + 1 + Y
IF LEN(tit$) > 4 THEN
IF UCASE$(RIGHT$(tit$, 4)) = ".BMP" THEN CALL Future.LoadBMP(tit$, X, Y)
IF UCASE$(RIGHT$(tit$, 4)) = ".PCX" THEN CALL Future.LoadPCX(tit$, X, Y)
IF UCASE$(RIGHT$(tit$, 4)) = ".GIF" THEN CALL Future.LoadGIF(tit$, X, Y)
END IF
SetViewPort 0, 0, Sys.MaxX, Sys.MaxY
END IF

END IF
'-------------------------------------------Frame----------------------------'-------------------------------------------Frame----------------------------------
IF OBJ = OFrame AND RVis <> 0 THEN
IF st AND CNoBorder THEN  ELSE CALL drawborder(XPR, Ypr, X1, Y1, UC, BC, DC)
IF st AND CCenter THEN s = 1 ELSE s = 0
IF st AND CPicture THEN  ELSE CALL PrintInBox(XPR + 2, Ypr + 2, X1 - 2, Y1 - 2, tit$, s, Tc, -1)

IF st AND CPicture THEN
SetViewPort XPR + 1, Ypr + 1, X1, Y1
X = XPR + 1
Y = Ypr + 1
IF LEN(tit$) > 4 THEN
IF UCASE$(RIGHT$(tit$, 4)) = ".BMP" THEN CALL Future.LoadBMP(tit$, X, Y)
IF UCASE$(RIGHT$(tit$, 4)) = ".PCX" THEN CALL Future.LoadPCX(tit$, X, Y)
IF UCASE$(RIGHT$(tit$, 4)) = ".GIF" THEN CALL Future.LoadGIF(tit$, X, Y)
END IF
SetViewPort 0, 0, Sys.MaxX, Sys.MaxY
END IF

END IF
'-------------------------------------------CheckBox----------------------------'-------------------------------------------CheckBox----------------------------
IF OBJ = OCheckBox AND RVis <> 0 THEN
IF st AND CNoBorder THEN
ELSE
CALL drawborder(XPR, Ypr, X1, Y1, UC, BC, DC)
END IF
V = GetProp(ID, PValue)
IF fts = 8 THEN ft = 8 ELSE ft = 10
IF V <> 0 THEN CALL drawpicto(XPR + 2, Ypr + 2, ft, 5, UC, BC, Tc, DC)
IF V = 0 THEN CALL drawborder(XPR + 2, Ypr + 2, XPR + ft + 2, Ypr + ft + 2, UC, BC, DC)

IF st AND CCenter THEN s = 1 ELSE s = 0
CALL PrintInBox(XPR + ft + 5, Ypr + 2, X1 - 2, Y1 - 2, tit$, s, Tc, -1)

END IF
'-------------------------------------------OptionBox----------------------------'-----------------------------------------OptionBox----------------------------
IF OBJ = OOptionBox AND RVis <> 0 THEN
IF st AND CNoBorder THEN
ELSE
CALL drawborder(XPR, Ypr, X1, Y1, UC, BC, DC)
END IF
V = GetProp(ID, PValue)
IF fts = 8 THEN ft = 8 ELSE ft = 10
IF V <> 0 THEN CALL drawpicto(XPR + 2, Ypr + 2, ft, 6, UC, BC, Tc, DC)
IF V = 0 THEN CALL drawborder(XPR + 2, Ypr + 2, XPR + ft + 2, Ypr + ft + 2, UC, BC, DC)

IF st AND CCenter THEN s = 1 ELSE s = 0
CALL PrintInBox(XPR + ft + 5, Ypr + 2, X1 - 2, Y1 - 2, tit$, s, Tc, -1)

END IF
'-------------------------------------------ScrollBar-------------------------'-------------------------------------------ScrollBar----------------------------
IF OBJ = OScrollBar AND RVis <> 0 THEN
st = GetProp(ID, PStyle)
max = GetProp(ID, PMaxValue)
min = GetProp(ID, PMinValue)
V = GetProp(ID, PValue)
VW = GetProp(ID, PVWidth)

IF V > max THEN V = max
IF V < min THEN V = min

CALL PutProp(ID, PValue, V)

IF st = CVertical THEN
IF min > V THEN PutProp ID, PValue, min
k# = (max - min + VW) / (YL - XL * 2 - 4)
IF k# <> 0 THEN
Wkk = VW / k# + 2
kk = (V - min) / k# + 1
END IF
CALL drawborder(XPR, Ypr + XL, X1, Y1 - XL, DC, DC, UC)
CALL drawpicto(XPR, Ypr, XL, 7, UC, BC, Tc, DC)
CALL drawpicto(XPR, Y1 - XL, XL, 8, UC, BC, Tc, DC)
CALL drawborder(XPR, kk + Ypr + XL, X1 - 1, kk + Ypr + Wkk + XL, UC, BC, DC)
END IF
IF st = CHorisontal OR st = 0 THEN
IF min > V THEN PutProp ID, PValue, min
k# = (max - min + VW) / (XL - YL * 2 - 4)
IF k# <> 0 THEN
Wkk = VW / k# + 2
kk = (V - min) / k# + 1
END IF
CALL drawborder(XPR + YL, Ypr, X1 - YL, Y1, DC, DC, UC)
CALL drawpicto(XPR, Ypr, YL, 9, UC, BC, Tc, DC)
CALL drawpicto(X1 - YL, Ypr, YL, 10, UC, BC, Tc, DC)
CALL drawborder(XPR + kk + YL, Ypr, XPR + kk + Wkk + YL, Y1 - 1, UC, BC, DC)

END IF

END IF
'-------------------------------------------TextBox----------------------------'-------------------------------------------TextBox----------------------------
IF (OBJ = OTextBox OR OBJ = OComboBox) AND RVis <> 0 THEN
Row = GetProp(ID, PRow)         'Y
Col = GetProp(ID, PCol)         'X
RRow = GetProp(ID, PRRow)         'Yr
RCol = GetProp(ID, PRCol)         'Xr
SelsRow = GetProp(ID, PSelSRow)         'Yr
selSCol = GetProp(ID, PSelSCol)         'Xr

ar = GetProp(ID, PArray)
SC = GetProp(ID, PScrollBar)

IF SC = CVertical THEN VS = -1
IF SC = CHorisontal THEN HS = -1
IF SC = CBoth THEN
VS = -1
HS = -1
END IF
IF OBJ = OComboBox THEN
ar = 0
VS = 0
HS = 0
CB = -1
END IF

TWR = FIX((YL - 2 + HS * 10) / fts)
TWC = FIX((XL - 2 + VS * 10 + CB * 10) / 8) - 1
'-------
IF Row < 0 THEN Row = 0
IF Col < 0 THEN Col = 0
IF RRow < 1 THEN RRow = 1
IF RCol < 1 THEN RCol = 1

IF ar <> 0 THEN
        IF st AND CDinamicRows THEN
                Rows = GetFArrRows(ar)
        ELSE
                Rows = GetArrRows(ar)
        END IF
ELSE
        Rows = 1
END IF

RW = RRow - Row
CW = RCol - Col
'-------
CALL drawFrame(XPR, Ypr, X1 - VS, Y1 - HS, UC, DC)
YY = Ypr + 2
IF ar <> 0 THEN

FOR I = Row + 1 TO Row + TWR
s$ = MID$(getarrs(ar, I), Col + 1, TWC + 1)


CALL Future.FILLBOX(XPR + 1, YY - 1, X1 + VS * 10 - 1, YY + fts, BC)
CALL Future.PRINT(XPR + 2, YY, s$, Tc, -1)

IF SelsRow <= I AND RRow >= I AND selSCol <= RCol AND selSCol > 0 AND SelsRow > 0 THEN

IF selSCol > Col THEN CALL PrintGfx(XPR + 2 + (selSCol - Col) * 8 - 8, YY, MID$(s$, selSCol - Col, RCol - selSCol + 1), BC, Tc)
IF selSCol <= Col THEN CALL PrintGfx(XPR + 2, YY, MID$(s$, 1, RCol - Col), BC, Tc)
ELSEIF SelsRow <= I AND RRow >= I AND selSCol = 0 AND SelsRow > 0 THEN
CALL PrintGfx(XPR + 2, YY, s$, BC, Tc)
END IF
YY = YY + fts
NEXT
CALL Future.FILLBOX(XPR + 1, YY, X1 + VS * 10 - 1, Y1 + HS * 10 - 1, BC)

IF ID = focus.ID THEN
YY = RW * fts - fts + 2
XX = CW * 8 - 6

s$ = MID$(getarrs(ar, RRow), RCol, 1)
IF s$ = "" THEN s$ = "_"
CALL PrintGfx(XPR + XX, Ypr + YY, s$, BC, Tc)
END IF

IF VS THEN
min = 0
max = Rows - TWR
V = Row
VW = TWR
k# = (max - min + VW) / (YL - (10 * 2 - HS * 10) - 6)
IF k# <> 0 THEN
Wkk = VW / k# + 2
kk = (V - min) / k# + 2
END IF
CALL drawborder(X1 - 10, Ypr + 11, X1, Y1 + HS * 10 - 11, Sys.DownColor, Sys.DownColor, Sys.UpColor)
CALL drawpicto(X1 - 10, Ypr + 1, 10, 7, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
CALL drawpicto(X1 - 10, Y1 + HS * 10 - 11, 10, 8, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
IF max > 0 THEN CALL drawborder(X1 - 10, kk + Ypr + 10, X1 - 1, kk + Ypr + Wkk + 10, Sys.UpColor, Sys.BColor, Sys.DownColor)
END IF
IF HS THEN
min = 0
max = GetArrCols(ar) - TWC - 1
V = Col
VW = TWC

k# = (max - min + VW) / (XL - 10 * 2 + VS * 10 - 6)
IF k# <> 0 THEN
Wkk = VW / k# + 2
kk = (V - min) / k# + 2
END IF
CALL drawborder(XPR + 10, Y1 - 10, X1 + VS * 10 - 10, Y1, Sys.DownColor, Sys.DownColor, Sys.UpColor)
CALL drawpicto(XPR + 1, Y1 - 10, 10, 9, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
CALL drawpicto(X1 + VS * 10 - 11, Y1 - 10, 10, 10, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
IF max > 0 THEN CALL drawborder(XPR + kk + 10, Y1 - 10, XPR + kk + Wkk + 10, Y1 - 1, Sys.UpColor, Sys.BColor, Sys.DownColor)
END IF

ELSE

s$ = MID$(title(ID), Col + 1, TWC + 1)
IF LEN(s$) <= TWC THEN s$ = s$ + SPACE$(TWC - LEN(s$) + 1)

CALL PrintGfx(X + 2, YY, s$, Tc, BC)

IF selSCol < RCol AND selSCol > 0 THEN
IF selSCol > Col THEN CALL PrintGfx(XPR + 2 + (selSCol - Col) * 8 - 8, YY, MID$(s$, selSCol - Col, RCol - selSCol + 1), BC, Tc)
IF selSCol <= Col THEN CALL PrintGfx(XPR + 2, YY, MID$(s$, 1, RCol - Col), BC, Tc)

END IF
IF ID = focus.ID THEN
s$ = MID$(title(ID), RCol, 1)

IF s$ = "" THEN s$ = "_"
XX = CW * 8 - 6
CALL PrintGfx(XPR + XX, Ypr + 2, s$, BC, Tc)

END IF
IF CB THEN
CALL drawpicto(X1 - YL + 1, Ypr + 1, YL - 2, 8, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF


END IF


END IF
'-------------------------------------------ListBox----------------------------'-------------------------------------------ListBox----------------------------
IF OBJ = OListBox AND RVis <> 0 THEN
Row = GetProp(ID, PRow)         'Y
Col = GetProp(ID, PCol)         'X
RRow = GetProp(ID, PRRow)         'Yr
RCol = GetProp(ID, PRCol)         'Xr

SelIndex = GetProp(ID, PSelIndex)         'Yr

ar = GetProp(ID, PArray)
SC = GetProp(ID, PScrollBar)
Cols = GetProp(ID, PCols)
colw = GetArrCols(ar)

IF st AND CDinamicRows THEN
Rows = GetFArrRows(ar)
frows = Rows
IF Cols < 1 THEN Cols = 1

DO UNTIL Rows \ Cols = Rows / Cols
Rows = Rows + 1
LOOP
ELSE
Rows = GetArrRows(ar)
frows = Rows
DO UNTIL Rows \ Cols = Rows / Cols
Rows = Rows - 1
LOOP

END IF
PutProp ID, PRows, Rows
PutProp ID, PCols, Cols

IF SC = CVertical THEN VS = -1
IF SC = CHorisontal THEN HS = -1
IF SC = CBoth THEN
VS = -1
HS = -1
END IF


TWR = FIX((YL - 2 + HS * 10) / fts)
TWC = FIX((XL - 2 + VS * 10) / 8)' - 1
'-------
IF Row < 0 THEN Row = 0
IF Col < 0 THEN Col = 0
IF RRow < 1 THEN RRow = 1
IF RCol < 1 THEN RCol = 1
RW = RRow - Row
CW = RCol - Col
'-------

Index = (RRow - 1) * (Cols) + RCol

IF Index > frows AND frows > 0 THEN
Index = frows
GetRowCol Index, Cols, RRow, ccc
IF RRow <= TWR THEN
RW = RRow: Row = 0
END IF
IF RRow > TWR THEN
Row = RRow - TWR
RW = TWR
END IF
PutProp ID, PRRow, RRow
PutProp ID, PRow, Row
END IF



IF RCol > Cols THEN
CW = WCols
Col = Cols - CW
RCol = Col + CW
END IF

IF frows = 0 THEN
Row = 0
RRow = 0
Col = 0
RCol = 0

END IF

'-------
CALL drawFrame(XPR, Ypr, X1 - VS, Y1 - HS, UC, DC)

CALL Future.FILLBOX(XPR + 1, Y1 + 10 * HS - fts + 1, X1 + VS * 10 - 1, Y1 + HS * 10 - 1, BC)

YY = Ypr + 2
XX = XPR + 2

FOR R = Row TO Row + TWR - 1
Y = YY + (R - Row) * fts
CALL Future.FILLBOX(XPR + 1, Y - 1, X1 + VS * 10 - 1, Y + fts, BC)

FOR C = Col TO Col + Cols - 1
IF FIX((C - Col + 1) * colw) > TWC AND Cols > 1 THEN EXIT FOR
s$ = SPACE$(colw - 1)
sa$ = ""

I = R * (Cols) + C + 1

IF I <= Rows THEN sa$ = getarrs(ar, I)
MID$(s$, 1, LEN(sa$)) = sa$
X = XX + (C - Col) * colw * 8
Y = YY + (R - Row) * fts
IF LEN(s$) > TWC AND Cols = 1 THEN
s$ = MID$(s$, 1, TWC)
END IF
IF R = RRow - 1 AND C = RCol - 1 AND focus.ID = ID THEN
CALL PrintGfx(X, Y, s$, BC, Tc)
ELSE
CALL PrintGfx(X, Y, s$, Tc, -1)
END IF

IF SelIndex <> 0 THEN
IF I >= SelIndex AND I <= Index THEN
CALL PrintGfx(X, Y, s$, BC, Tc)

END IF
END IF

NEXT
NEXT
min = 0
IF VS THEN
max = FIX((Rows / Cols)) - TWR
V = Row
VW = TWR
k# = (max - min + VW) / (YL - (10 * 2 - HS * 10) - 6)
IF k# <> 0 THEN
Wkk = VW / k# + 2

kk = (V - min) / k# + 2
END IF
CALL drawborder(X1 - 10, Ypr + 11, X1, Y1 + HS * 10 - 11, Sys.DownColor, Sys.DownColor, Sys.UpColor)
CALL drawpicto(X1 - 10, Ypr + 1, 10, 7, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
CALL drawpicto(X1 - 10, Y1 + HS * 10 - 11, 10, 8, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
IF max > 0 THEN CALL drawborder(X1 - 10, kk + Ypr + 10, X1 - 1, kk + Ypr + Wkk + 10, Sys.UpColor, Sys.BColor, Sys.DownColor)
END IF

IF HS THEN
min = 0
max = Cols - FIX(TWC / colw)
V = Col
VW = 1

k# = (max - min + VW) / (XL - 10 * 2 + VS * 10 - 6)
IF k# <> 0 THEN
Wkk = VW / k# + 2
kk = (V - min) / k# + 2
END IF
CALL drawborder(XPR + 10, Y1 - 10, X1 + VS * 10 - 10, Y1, Sys.DownColor, Sys.DownColor, Sys.UpColor)
CALL drawpicto(XPR + 1, Y1 - 10, 10, 9, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
CALL drawpicto(X1 + VS * 10 - 11, Y1 - 10, 10, 10, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
IF max > 0 THEN CALL drawborder(XPR + kk + 10, Y1 - 10, XPR + kk + Wkk + 10, Y1 - 1, Sys.UpColor, Sys.BColor, Sys.DownColor)
END IF



END IF
'-------------------------------------Menu-----------------------------------------------------Menu--------------------------------------------Menu------------------------------------
IF OBJ = OMenu AND RVis <> 0 THEN
REDIM mnu(25) AS STRING

TLE = LEN(tit$)
CALL drawborder(XPR, Ypr, X1, Y1, BC, BC, BC)

I = 1
DO
il = INSTR(I, tit$, "&") - I

IF il > 0 THEN l = il
s$ = MID$(tit$, I, l)
I = I + l + 1
mnu(k) = s$
k = k + 1
LOOP UNTIL I >= TLE
X = 0
l = 0
V = GetProp(ID, PValue)
VS = GetProp(ID, PSelValue)

FOR I = 0 TO k - 1

X = X + l + 1
l = LEN(mnu(I)) * 8 + 16
X1 = X + l
IF V = I + 1 AND (GetProp(ID, PLMHold) OR GetProp(ID, PLMDown)) THEN
CALL drawborder(XPR + X, Ypr, XPR + X1, Y1, DC, BC, UC)
CALL PrintGfx(XPR + X + 9, Ypr + 3, mnu(I), Tc, -1)
ELSE
IF (st AND CNoBorder) = 0 THEN CALL drawborder(XPR + X, Ypr, XPR + X1, Y1, UC, BC, DC)
CALL PrintGfx(XPR + X + 8, Ypr + 2, mnu(I), Tc, -1)
END IF

IF VS = I + 1 AND (GetProp(ID, PLMHold) = 0 AND GetProp(ID, PLMDown) = 0) THEN
CALL drawborder(XPR + X + 1, Ypr + 1, XPR + X1 - 1, Y1 - 1, UC, BC, DC)
CALL PrintGfx(XPR + X + 8, Ypr + 2, mnu(I), Tc, -1)
END IF

NEXT
END IF
IF OBJ = OPictureBox AND RVis <> 0 THEN

IF st AND CNoBorder THEN
ELSE
CALL drawborder(XPR, Ypr, X1, Y1, UC, BC, DC)
END IF

SetViewPort XPR + 1, Ypr + 1, X1, Y1
XX = GetProp(ID, PImgXPos)
YY = GetProp(ID, PImgYPos)
X = XPR + XX + 1
Y = Ypr + XX + 1
IF LEN(tit$) > 4 THEN
IF UCASE$(RIGHT$(tit$, 4)) = ".BMP" THEN CALL Future.LoadBMP(tit$, X, Y)
IF UCASE$(RIGHT$(tit$, 4)) = ".PCX" THEN CALL Future.LoadPCX(tit$, X, Y)
IF UCASE$(RIGHT$(tit$, 4)) = ".GIF" THEN CALL Future.LoadGIF(tit$, X, Y)
END IF
SetViewPort 0, 0, Sys.MaxX, Sys.MaxY
END IF
IF OBJ = OImageBox AND RVis <> 0 THEN

IF st AND CNoBorder THEN
ELSE
CALL drawborder(XPR, Ypr, X1, Y1, UC, BC, DC)
END IF

SetViewPort XPR + 1, Ypr + 1, X1, Y1
XX = GetProp(ID, PImgXPos)
YY = GetProp(ID, PImgYPos)
X = XPR + XX + 1
Y = Ypr + XX + 1
ar = GetProp(ID, PArray)
I = GetProp(ID, PImgIndex)

IF ar <> 0 THEN
Future.XMSArrayPut X, Y, ar, I
END IF

SetViewPort 0, 0, Sys.MaxX, Sys.MaxY

END IF

'======================================================================-

CALL PutProp(ID, PNoRefresh, 1)
END SUB

SUB splitPath (Path$, Drive$, Dire$, file$, ext$)
s$ = Path$
LL = LEN(s$)
l = LL
IF l < 1 THEN EXIT SUB
'------------------------------------

FOR I = l TO 1 STEP -1
D$ = MID$(s$, I, 1)
IF D$ = "." THEN
extl = LL - I + 1
ext$ = RIGHT$(s$, extl)
l = I - 1
EXIT FOR
END IF
NEXT
'-----------------------------------
FOR I = l TO 1 STEP -1
D$ = MID$(s$, I, 1)
IF D$ = "\" THEN
file$ = MID$(s$, I + 1, l - I)
filel = l - I - 1
l = I
EXIT FOR
END IF
NEXT
IF (filel = 0) AND (LL > extl) THEN
file$ = LEFT$(s$, l)
filel = LEN(file$)
END IF

'---------------------------

FOR I = l TO 1 STEP -1
D$ = MID$(s$, I, 1)
IF D$ = ":" THEN
Dire$ = MID$(s$, I + 2, l - I - 1)
Drive$ = LEFT$(s$, I + 1)
pathl = l - I - 1
l = I
EXIT FOR
END IF
NEXT

IF (pathl = 0) AND (LL > extl + filel) AND (MID$(s$, l, 1) <> ":") THEN
Dire$ = LEFT$(s$, l)

END IF
'-----------------------------------
END SUB

SUB UnPackString (INString$, RetArray() AS STRING, RetRows, RetCols)
tit$ = INString$
TLE = LEN(tit$)

I = 1
DO
k = k + 1
il = INSTR(I, tit$, "&") - I
IF il > 0 THEN l = il
s$ = MID$(tit$, I, l)
I = I + l + 1
RetArray(k) = s$
IF RetCols < LEN(s$) THEN RetCols = LEN(s$)
LOOP UNTIL I >= TLE
RetRows = k

END SUB

